import { BehaviorSubject, from, Observable, of, timer, zip } from 'rxjs';
import { map, tap } from 'rxjs/operators';
import { __awaiter } from 'tslib';
import { DOCUMENT } from '@angular/common';
import { InjectionToken, Inject, Injectable, defineInjectable, inject, NgModule, Component, ViewEncapsulation, Input, ViewChild } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const HighlightJsConfigToken = new InjectionToken('HighlightJsConfig');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
const Language = {
    '1C': '1C',
    'ABNF': 'ABNF',
    'ACCESSLOG': 'ACCESSLOG',
    'ACTIONSCRIPT': 'ACTIONSCRIPT',
    'ADA': 'ADA',
    'ANGELSCRIPT': 'ANGELSCRIPT',
    'APACHE': 'APACHE',
    'APPLESCRIPT': 'APPLESCRIPT',
    'ARCADE': 'ARCADE',
    'ARDUINO': 'ARDUINO',
    'ARMASM': 'ARMASM',
    'ASCIIDOC': 'ASCIIDOC',
    'ASPECTJ': 'ASPECTJ',
    'AUTOHOTKEY': 'AUTOHOTKEY',
    'AUTOIT': 'AUTOIT',
    'AVRASM': 'AVRASM',
    'AWK': 'AWK',
    'AXAPTA': 'AXAPTA',
    'BASH': 'BASH',
    'BASIC': 'BASIC',
    'BNF': 'BNF',
    'BRAINFUCK': 'BRAINFUCK',
    'CAL': 'CAL',
    'CAPNPROTO': 'CAPNPROTO',
    'CEYLON': 'CEYLON',
    'CLEAN': 'CLEAN',
    'CLOJURE-REPL': 'CLOJURE-REPL',
    'CLOJURE': 'CLOJURE',
    'CMAKE': 'CMAKE',
    'COFFEESCRIPT': 'COFFEESCRIPT',
    'COQ': 'COQ',
    'COS': 'COS',
    'CPP': 'CPP',
    'CRMSH': 'CRMSH',
    'CRYSTAL': 'CRYSTAL',
    'CS': 'CS',
    'CSP': 'CSP',
    'CSS': 'CSS',
    'D': 'D',
    'DART': 'DART',
    'DELPHI': 'DELPHI',
    'DIFF': 'DIFF',
    'DJANGO': 'DJANGO',
    'DNS': 'DNS',
    'DOCKERFILE': 'DOCKERFILE',
    'DOS': 'DOS',
    'DSCONFIG': 'DSCONFIG',
    'DTS': 'DTS',
    'DUST': 'DUST',
    'EBNF': 'EBNF',
    'ELIXIR': 'ELIXIR',
    'ELM': 'ELM',
    'ERB': 'ERB',
    'ERLANG-REPL': 'ERLANG-REPL',
    'ERLANG': 'ERLANG',
    'EXCEL': 'EXCEL',
    'FIX': 'FIX',
    'FLIX': 'FLIX',
    'FORTRAN': 'FORTRAN',
    'FSHARP': 'FSHARP',
    'GAMS': 'GAMS',
    'GAUSS': 'GAUSS',
    'GCODE': 'GCODE',
    'GHERKIN': 'GHERKIN',
    'GLSL': 'GLSL',
    'GML': 'GML',
    'GO': 'GO',
    'GOLO': 'GOLO',
    'GRADLE': 'GRADLE',
    'GROOVY': 'GROOVY',
    'HAML': 'HAML',
    'HANDLEBARS': 'HANDLEBARS',
    'HASKELL': 'HASKELL',
    'HAXE': 'HAXE',
    'HSP': 'HSP',
    'HTMLBARS': 'HTMLBARS',
    'HTTP': 'HTTP',
    'HY': 'HY',
    'INFORM7': 'INFORM7',
    'INI': 'INI',
    'IRPF90': 'IRPF90',
    'ISBL': 'ISBL',
    'JAVA': 'JAVA',
    'JAVASCRIPT': 'JAVASCRIPT',
    'JBOSS-CLI': 'JBOSS-CLI',
    'JSON': 'JSON',
    'JULIA-REPL': 'JULIA-REPL',
    'JULIA': 'JULIA',
    'KOTLIN': 'KOTLIN',
    'LASSO': 'LASSO',
    'LDIF': 'LDIF',
    'LEAF': 'LEAF',
    'LESS': 'LESS',
    'LISP': 'LISP',
    'LIVECODESERVER': 'LIVECODESERVER',
    'LIVESCRIPT': 'LIVESCRIPT',
    'LLVM': 'LLVM',
    'LSL': 'LSL',
    'LUA': 'LUA',
    'MAKEFILE': 'MAKEFILE',
    'MARKDOWN': 'MARKDOWN',
    'MATHEMATICA': 'MATHEMATICA',
    'MATLAB': 'MATLAB',
    'MAXIMA': 'MAXIMA',
    'MEL': 'MEL',
    'MERCURY': 'MERCURY',
    'MIPSASM': 'MIPSASM',
    'MIZAR': 'MIZAR',
    'MOJOLICIOUS': 'MOJOLICIOUS',
    'MONKEY': 'MONKEY',
    'MOONSCRIPT': 'MOONSCRIPT',
    'N1QL': 'N1QL',
    'NGINX': 'NGINX',
    'NIMROD': 'NIMROD',
    'NIX': 'NIX',
    'NSIS': 'NSIS',
    'OBJECTIVEC': 'OBJECTIVEC',
    'OCAML': 'OCAML',
    'OPENSCAD': 'OPENSCAD',
    'OXYGENE': 'OXYGENE',
    'PARSER3': 'PARSER3',
    'PERL': 'PERL',
    'PF': 'PF',
    'PGSQL': 'PGSQL',
    'PHP': 'PHP',
    'PLAINTEXT': 'PLAINTEXT',
    'PONY': 'PONY',
    'POWERSHELL': 'POWERSHELL',
    'PROCESSING': 'PROCESSING',
    'PROFILE': 'PROFILE',
    'PROLOG': 'PROLOG',
    'PROPERTIES': 'PROPERTIES',
    'PROTOBUF': 'PROTOBUF',
    'PUPPET': 'PUPPET',
    'PUREBASIC': 'PUREBASIC',
    'PYTHON': 'PYTHON',
    'Q': 'Q',
    'QML': 'QML',
    'R': 'R',
    'REASONML': 'REASONML',
    'RIB': 'RIB',
    'ROBOCONF': 'ROBOCONF',
    'ROUTEROS': 'ROUTEROS',
    'RSL': 'RSL',
    'RUBY': 'RUBY',
    'RULESLANGUAGE': 'RULESLANGUAGE',
    'RUST': 'RUST',
    'SAS': 'SAS',
    'SCALA': 'SCALA',
    'SCHEME': 'SCHEME',
    'SCILAB': 'SCILAB',
    'SCSS': 'SCSS',
    'SHELL': 'SHELL',
    'SMALI': 'SMALI',
    'SMALLTALK': 'SMALLTALK',
    'SML': 'SML',
    'SQF': 'SQF',
    'SQL': 'SQL',
    'STAN': 'STAN',
    'STATA': 'STATA',
    'STEP21': 'STEP21',
    'STYLUS': 'STYLUS',
    'SUBUNIT': 'SUBUNIT',
    'SWIFT': 'SWIFT',
    'TAGGERSCRIPT': 'TAGGERSCRIPT',
    'TAP': 'TAP',
    'TCL': 'TCL',
    'TEX': 'TEX',
    'THRIFT': 'THRIFT',
    'TP': 'TP',
    'TWIG': 'TWIG',
    'TYPESCRIPT': 'TYPESCRIPT',
    'VALA': 'VALA',
    'VBNET': 'VBNET',
    'VBSCRIPT-HTML': 'VBSCRIPT-HTML',
    'VBSCRIPT': 'VBSCRIPT',
    'VERILOG': 'VERILOG',
    'VHDL': 'VHDL',
    'VIM': 'VIM',
    'X86ASM': 'X86ASM',
    'XL': 'XL',
    'XML': 'XML',
    'XQUERY': 'XQUERY',
    'YAML': 'YAML',
    'ZEPHIR': 'ZEPHIR',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class HighlightJsService {
    /**
     * @param {?} config
     */
    constructor(config) {
        this.config = config;
        this._initialized = new BehaviorSubject(false);
        // TODO - Make the timeout configurable configurable
        this._timeoutError = 60000; // ms
        // ms
        this._hljsSubject = new BehaviorSubject(null);
        this._init();
    }
    /**
     * @param {?} lang
     * @return {?}
     */
    registerLanguage(lang) {
        // I converted this method to use observables but the dynamic import + dynamic lang name
        // does not play nice.  Wrapping the import like from(import()) does not work.  Which is
        // a shame because the code is much cleaner :(
        return new Promise((resolveMain, rejectMain) => {
            /** @type {?} */
            const l = lang.toLowerCase();
            import(`highlight.js/lib/languages/${l}`).then(javascript => {
                this._executeHljsCommand(hljs => {
                    hljs.registerLanguage(l, javascript.default);
                }).subscribe(result => {
                    resolveMain(result);
                }, err => {
                    resolveMain(false);
                    console.error(`Error loading highlight.js language: ${l}.`);
                    console.error('Error', err);
                });
            });
        });
    }
    /**
     * @param {?} block
     * @return {?}
     */
    highlightBlock(block) {
        return this._executeHljsCommand(hljs => {
            hljs.highlightBlock(block.nativeElement);
        });
    }
    /**
     * @private
     * @return {?}
     */
    _init() {
        /** @type {?} */
        let hljsObs;
        if (this._allLanguagesSpecifed(this.config)) {
            hljsObs = this._initHljsWithAllLanguages();
        }
        else {
            hljsObs = zip(this._initHljsWithNoLanguages(), this._registerLanguagesFromConfig());
        }
        hljsObs.subscribe(hljs => {
            // console.log('hljs-init-complete', hljs);
            this._initialized.next(true);
        });
    }
    /**
     * @private
     * @param {?} config
     * @return {?}
     */
    _allLanguagesSpecifed(config) {
        return config != null && config.languages === 'all';
    }
    /**
     * @private
     * @param {?} config
     * @return {?}
     */
    _someLanguagesSpecified(config) {
        return (config != null && config.languages != null && config.languages.length > 0);
    }
    /**
     * @private
     * @return {?}
     */
    _registerLanguagesFromConfig() {
        if (this.config.languages == null) {
            // console.log('no-languages');
            return of({});
        }
        return from(this.config.languages).pipe(map(lang => from(this.registerLanguage(Language[lang]))));
    }
    /**
     * @private
     * @return {?}
     */
    _initHljsWithNoLanguages() {
        /** @type {?} */
        const obs = from(import('highlight.js/lib/highlight'));
        return this._mapHljs(obs);
    }
    /**
     * @private
     * @return {?}
     */
    _initHljsWithAllLanguages() {
        /** @type {?} */
        const obs = from(import('highlight.js'));
        return this._mapHljs(obs);
    }
    /**
     * @private
     * @param {?} hljsObs
     * @return {?}
     */
    _mapHljs(hljsObs) {
        return hljsObs.pipe(
        // delay(5000),
        tap(hljs => {
            /** @type {?} */
            const library = hljs.default;
            library.configure(Object.assign({}));
            this._hljsSubject.next(library);
        }));
    }
    /**
     * @private
     * @param {?} hljsFn
     * @return {?}
     */
    _executeHljsCommand(hljsFn) {
        // The purpose of this method is to wrap all hljs calls with timeout logic.
        // Since hljs is loaded asynchronously we can only access it through our Subject.
        // So we wrap it in this method so we don't have to duplicate timer code all over
        // the place.
        return new Observable(observer => {
            /** @type {?} */
            let hljsSub;
            /** @type {?} */
            const t = timer(this._timeoutError).subscribe(() => {
                hljsSub.unsubscribe();
                observer.error(`Failed to load Highlight.js within ${this._timeoutError}ms`);
            });
            hljsSub = this._hljsSubject.subscribe(hljs => {
                if (hljs != null) {
                    // Execute our hljs command
                    hljsFn(hljs);
                    if (t != null) {
                        t.unsubscribe();
                    }
                    observer.next(true);
                    observer.complete();
                }
            });
        });
    }
}
HighlightJsService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
HighlightJsService.ctorParameters = () => [
    { type: undefined, decorators: [{ type: Inject, args: [HighlightJsConfigToken,] }] }
];
/** @nocollapse */ HighlightJsService.ngInjectableDef = defineInjectable({ factory: function HighlightJsService_Factory() { return new HighlightJsService(inject(HighlightJsConfigToken)); }, token: HighlightJsService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
const SyntaxStyle = {
    'A11Y-DARK': 'a11y-dark.css',
    'A11Y-LIGHT': 'a11y-light.css',
    'AGATE': 'agate.css',
    'AN-OLD-HOPE': 'an-old-hope.css',
    'ANDROIDSTUDIO': 'androidstudio.css',
    'ARDUINO-LIGHT': 'arduino-light.css',
    'ARTA': 'arta.css',
    'ASCETIC': 'ascetic.css',
    'ATELIER-CAVE-DARK': 'atelier-cave-dark.css',
    'ATELIER-CAVE-LIGHT': 'atelier-cave-light.css',
    'ATELIER-DUNE-DARK': 'atelier-dune-dark.css',
    'ATELIER-DUNE-LIGHT': 'atelier-dune-light.css',
    'ATELIER-ESTUARY-DARK': 'atelier-estuary-dark.css',
    'ATELIER-ESTUARY-LIGHT': 'atelier-estuary-light.css',
    'ATELIER-FOREST-DARK': 'atelier-forest-dark.css',
    'ATELIER-FOREST-LIGHT': 'atelier-forest-light.css',
    'ATELIER-HEATH-DARK': 'atelier-heath-dark.css',
    'ATELIER-HEATH-LIGHT': 'atelier-heath-light.css',
    'ATELIER-LAKESIDE-DARK': 'atelier-lakeside-dark.css',
    'ATELIER-LAKESIDE-LIGHT': 'atelier-lakeside-light.css',
    'ATELIER-PLATEAU-DARK': 'atelier-plateau-dark.css',
    'ATELIER-PLATEAU-LIGHT': 'atelier-plateau-light.css',
    'ATELIER-SAVANNA-DARK': 'atelier-savanna-dark.css',
    'ATELIER-SAVANNA-LIGHT': 'atelier-savanna-light.css',
    'ATELIER-SEASIDE-DARK': 'atelier-seaside-dark.css',
    'ATELIER-SEASIDE-LIGHT': 'atelier-seaside-light.css',
    'ATELIER-SULPHURPOOL-DARK': 'atelier-sulphurpool-dark.css',
    'ATELIER-SULPHURPOOL-LIGHT': 'atelier-sulphurpool-light.css',
    'ATOM-ONE-DARK-REASONABLE': 'atom-one-dark-reasonable.css',
    'ATOM-ONE-DARK': 'atom-one-dark.css',
    'ATOM-ONE-LIGHT': 'atom-one-light.css',
    'BROWN-PAPER': 'brown-paper.css',
    'BROWN-PAPERSQ': 'brown-papersq.png',
    'CODEPEN-EMBED': 'codepen-embed.css',
    'COLOR-BREWER': 'color-brewer.css',
    'DARCULA': 'darcula.css',
    'DARK': 'dark.css',
    'DARKULA': 'darkula.css',
    'DEFAULT': 'default.css',
    'DOCCO': 'docco.css',
    'DRACULA': 'dracula.css',
    'FAR': 'far.css',
    'FOUNDATION': 'foundation.css',
    'GITHUB-GIST': 'github-gist.css',
    'GITHUB': 'github.css',
    'GML': 'gml.css',
    'GOOGLECODE': 'googlecode.css',
    'GRAYSCALE': 'grayscale.css',
    'GRUVBOX-DARK': 'gruvbox-dark.css',
    'GRUVBOX-LIGHT': 'gruvbox-light.css',
    'HOPSCOTCH': 'hopscotch.css',
    'HYBRID': 'hybrid.css',
    'IDEA': 'idea.css',
    'IR-BLACK': 'ir-black.css',
    'ISBL-EDITOR-DARK': 'isbl-editor-dark.css',
    'ISBL-EDITOR-LIGHT': 'isbl-editor-light.css',
    'KIMBIE.DARK': 'kimbie.dark.css',
    'KIMBIE.LIGHT': 'kimbie.light.css',
    'LIGHTFAIR': 'lightfair.css',
    'MAGULA': 'magula.css',
    'MONO-BLUE': 'mono-blue.css',
    'MONOKAI-SUBLIME': 'monokai-sublime.css',
    'MONOKAI': 'monokai.css',
    'NORD': 'nord.css',
    'OBSIDIAN': 'obsidian.css',
    'OCEAN': 'ocean.css',
    'PARAISO-DARK': 'paraiso-dark.css',
    'PARAISO-LIGHT': 'paraiso-light.css',
    'POJOAQUE': 'pojoaque.css',
    'PUREBASIC': 'purebasic.css',
    'QTCREATOR_DARK': 'qtcreator_dark.css',
    'QTCREATOR_LIGHT': 'qtcreator_light.css',
    'RAILSCASTS': 'railscasts.css',
    'RAINBOW': 'rainbow.css',
    'ROUTEROS': 'routeros.css',
    'SCHOOL-BOOK': 'school-book.css',
    'SHADES-OF-PURPLE': 'shades-of-purple.css',
    'SOLARIZED-DARK': 'solarized-dark.css',
    'SOLARIZED-LIGHT': 'solarized-light.css',
    'SUNBURST': 'sunburst.css',
    'TOMORROW-NIGHT-BLUE': 'tomorrow-night-blue.css',
    'TOMORROW-NIGHT-BRIGHT': 'tomorrow-night-bright.css',
    'TOMORROW-NIGHT-EIGHTIES': 'tomorrow-night-eighties.css',
    'TOMORROW-NIGHT': 'tomorrow-night.css',
    'TOMORROW': 'tomorrow.css',
    'VS': 'vs.css',
    'VS2015': 'vs2015.css',
    'XCODE': 'xcode.css',
    'XT256': 'xt256.css',
    'ZENBURN': 'zenburn.css',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class StyleService {
    /**
     * @param {?} document
     * @param {?} config
     */
    constructor(document, config) {
        this.document = document;
        this.config = config;
        this.STYLE_NODE_ID = 'highlightJsStyleNode';
    }
    /**
     * @param {?} style
     * @return {?}
     */
    registerStyle(style) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.existingStyle || (style && this.existingStyle !== style)) {
                style = style || this.config.style || this._getDefaultStyle();
                this.existingStyle = style;
            }
            else {
                return Promise.resolve();
            }
            return new Promise((resolveMain, rejectMain) => {
                /** @type {?} */
                const s = style.toLowerCase();
                import(`highlight.js/styles/${s}`).then(css => {
                    this._addStyleToDocument(css.default);
                    resolveMain(true);
                });
            });
        });
    }
    /**
     * @return {?}
     */
    removeStyleNode() {
        /** @type {?} */
        const node = this.document.getElementById(this.STYLE_NODE_ID);
        if (node != null) {
            console.log('remove-style-node');
            node.parentNode.removeChild(node);
        }
    }
    /**
     * @private
     * @param {?} styles
     * @return {?}
     */
    _addStyleToDocument(styles) {
        /** @type {?} */
        const node = this._createStyleElement();
        node.innerHTML = styles;
        this.document.body.appendChild(node);
    }
    /**
     * @private
     * @return {?}
     */
    _createStyleElement() {
        this.removeStyleNode();
        /** @type {?} */
        const styleNode = this.document.createElement('style');
        styleNode.id = this.STYLE_NODE_ID;
        return styleNode;
    }
    /**
     * @private
     * @return {?}
     */
    _getDefaultStyle() {
        return SyntaxStyle.GITHUB;
    }
}
StyleService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
StyleService.ctorParameters = () => [
    { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] },
    { type: undefined, decorators: [{ type: Inject, args: [HighlightJsConfigToken,] }] }
];
/** @nocollapse */ StyleService.ngInjectableDef = defineInjectable({ factory: function StyleService_Factory() { return new StyleService(inject(DOCUMENT), inject(HighlightJsConfigToken)); }, token: StyleService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxSyntaxHighlighterComponent {
    /**
     * @param {?} styleService
     * @param {?} highlightJsService
     */
    constructor(styleService, highlightJsService) {
        this.styleService = styleService;
        this.highlightJsService = highlightJsService;
    }
    /**
     * @param {?} s
     * @return {?}
     */
    set style(s) {
        this._setStyle(s);
    }
    /**
     * @return {?}
     */
    get style() {
        return this._style;
    }
    /**
     * @return {?}
     */
    ngOnInit() { }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        return __awaiter(this, void 0, void 0, function* () {
            this.highlightJsService._initialized.subscribe((serviceInitialized) => __awaiter(this, void 0, void 0, function* () {
                if (!serviceInitialized) {
                    return;
                }
                yield this.styleService.registerStyle(this.style);
                console.log(this.language);
                if (this.language != null) {
                    console.log(this.language);
                    yield this.highlightJsService.registerLanguage(this.language);
                }
                this._initialized = true;
                // this.codeElement.nativeElement.innerHTML = this.code;
                // console.log(this.codeElement.nativeElement.innerHTML);
                this._runHighlighter();
            }));
        });
    }
    /**
     * @private
     * @param {?} style
     * @return {?}
     */
    _setStyle(style) {
        return __awaiter(this, void 0, void 0, function* () {
            this._style = style;
            console.log('set-style', style);
            if (this._initialized) {
                yield this.styleService.registerStyle(style);
                this._runHighlighter();
            }
        });
    }
    /**
     * @private
     * @return {?}
     */
    _runHighlighter() {
        this.highlightJsService.highlightBlock(this.preElement).subscribe(result => {
            console.log('run-highlighter-result', result);
        }, err => {
            console.log('run-highlighter-error', err);
        }, () => {
            console.log('run-highlighter-complete');
        });
    }
}
NgxSyntaxHighlighterComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-syntax-highlighter',
                template: "<pre #preElement>\r\n  <!-- <code #codeElement class=\"{{language.toLowerCase()}}\"> -->\r\n      <code #codeElement>\r\n    {{code}}\r\n  </code>\r\n</pre>\r\n",
                encapsulation: ViewEncapsulation.None,
                styles: [""]
            }] }
];
/** @nocollapse */
NgxSyntaxHighlighterComponent.ctorParameters = () => [
    { type: StyleService },
    { type: HighlightJsService }
];
NgxSyntaxHighlighterComponent.propDecorators = {
    style: [{ type: Input, args: ['style',] }],
    language: [{ type: Input }],
    code: [{ type: Input }],
    codeContainerElement: [{ type: ViewChild, args: ['codeContainer',] }],
    preElement: [{ type: ViewChild, args: ['preElement',] }],
    codeElement: [{ type: ViewChild, args: ['codeElement',] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxHighlightJsModule {
    /**
     * @param {?=} config
     * @return {?}
     */
    static forRoot(config) {
        return {
            ngModule: NgxHighlightJsModule,
            providers: [{ provide: HighlightJsConfigToken, useValue: config }]
        };
    }
}
NgxHighlightJsModule.decorators = [
    { type: NgModule, args: [{
                declarations: [NgxSyntaxHighlighterComponent],
                imports: [],
                exports: [NgxSyntaxHighlighterComponent]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxSyntaxHighlighterComponent, NgxHighlightJsModule, SyntaxStyle, Language, HighlightJsConfigToken as ɵb, HighlightJsService as ɵc, StyleService as ɵa };

//# sourceMappingURL=ngx-syntax-highlighter.js.map