import { BehaviorSubject, Observable } from 'rxjs';
import { ElementRef } from '@angular/core';
import { HighlightJsConfig } from '../highlight-js-config';
import { Language } from '../language.enum';
export declare class HighlightJsService {
    private config;
    _initialized: BehaviorSubject<any>;
    _timeoutError: number;
    private _hljsSubject;
    constructor(config: HighlightJsConfig);
    registerLanguage(lang: Language): Promise<boolean>;
    highlightBlock(block: ElementRef): Observable<boolean>;
    private _init;
    private _allLanguagesSpecifed;
    private _someLanguagesSpecified;
    private _registerLanguagesFromConfig;
    private _initHljsWithNoLanguages;
    private _initHljsWithAllLanguages;
    private _mapHljs;
    private _executeHljsCommand;
}
